var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as React from 'react';
import { componentDefaultProps } from './component-common';
import ErrorMessages from './error-messages';
import Help from './help';
import Row from './row';
var defaultProps = __assign(__assign({}, componentDefaultProps), { value: false, valueLabel: '', elementRef: React.createRef() });
var Checkbox = /** @class */ (function (_super) {
    __extends(Checkbox, _super);
    // Need to supply a constructor to be recognised as ComponentClass?
    function Checkbox(props) {
        var _this = _super.call(this, props) || this;
        _this.handleChange = function (event) {
            var value = event.currentTarget.checked;
            var _a = _this.props, onSetValue = _a.onSetValue, changeCallback = _a.changeCallback, name = _a.name;
            onSetValue(value);
            changeCallback(name, value);
        };
        _this.renderElement = function () {
            var _a = _this.props, elementRef = _a.elementRef, id = _a.id, label = _a.label, value = _a.value, valueLabel = _a.valueLabel, inputProps = __rest(_a, ["elementRef", "id", "label", "value", "valueLabel"]);
            Object.keys(componentDefaultProps).forEach(function (key) {
                delete inputProps[key];
            });
            return (React.createElement("div", { className: "custom-control custom-checkbox" },
                React.createElement("input", __assign({}, inputProps, { checked: value === true, className: "custom-control-input", id: id, onChange: _this.handleChange, ref: elementRef, type: "checkbox" })),
                React.createElement("label", { className: "custom-control-label", htmlFor: id }, valueLabel)));
        };
        return _this;
    }
    Checkbox.prototype.render = function () {
        var element = this.renderElement();
        var _a = this.props, errorMessages = _a.errorMessages, help = _a.help, id = _a.id, labelClassName = _a.labelClassName, layout = _a.layout, showErrors = _a.showErrors;
        if (layout === 'elementOnly') {
            return element;
        }
        return (React.createElement(Row, __assign({}, this.props, { fakeLabel: true, htmlFor: id, labelClassName: ['pt-0', labelClassName] }),
            React.createElement(React.Fragment, null,
                element,
                help ? React.createElement(Help, { help: help }) : null,
                showErrors ? React.createElement(ErrorMessages, { messages: errorMessages }) : null)));
    };
    Checkbox.defaultProps = defaultProps;
    return Checkbox;
}(React.Component));
export default Checkbox;
//# sourceMappingURL=checkbox.js.map