var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as React from 'react';
import classNames from 'classnames/dedupe'; // eslint-disable-line import/default
var SelectControl = /** @class */ (function (_super) {
    __extends(SelectControl, _super);
    function SelectControl(props) {
        var _this = _super.call(this, props) || this;
        _this.renderOption = function (item, key) {
            var label = item.label, value = item.value, rest = __rest(item, ["label", "value"]);
            var option = (React.createElement("option", __assign({ key: key, value: value }, rest), label));
            return option;
        };
        return _this;
    }
    SelectControl.prototype.render = function () {
        var _this = this;
        var options = this.props.options;
        var groups = options
            .filter(function (item) { return (item.group ? item.group : ''); })
            .map(function (item) { return (item.group ? item.group : ''); });
        // Get the unique items in group.
        var onlyUnique = function (value, index, self) {
            return self.indexOf(value) === index;
        };
        groups = groups.filter(onlyUnique);
        var optionNodes;
        if (groups.length === 0) {
            optionNodes = options.map(function (item, index) {
                return _this.renderOption(item, "" + index);
            });
        }
        else {
            // For items without groups.
            var itemsWithoutGroup = options.filter(function (item) { return !item.group; });
            optionNodes = itemsWithoutGroup.map(function (item, index) {
                return _this.renderOption(item, "no-group-" + index);
            });
            groups.forEach(function (group, groupIndex) {
                var groupItems = options.filter(function (item) { return item.group === group; });
                var groupOptionNodes = groupItems.map(function (item, index) {
                    return _this.renderOption(item, groupIndex + "-" + index);
                });
                optionNodes.push(React.createElement("optgroup", { label: group, key: groupIndex }, groupOptionNodes));
            });
        }
        var _a = this.props, className = _a.className, elementRef = _a.elementRef, selectProps = __rest(_a, ["className", "elementRef"]);
        delete selectProps.options;
        return (React.createElement("select", __assign({}, selectProps, { className: classNames(['custom-select', className]), ref: elementRef }), optionNodes));
    };
    SelectControl.defaultProps = {
        multiple: false,
        elementRef: React.createRef(),
    };
    return SelectControl;
}(React.Component));
export default SelectControl;
//# sourceMappingURL=select.js.map