import * as React from 'react';
import { componentDefaultProps } from './component-common';
import { InputControlProps } from './controls/input';
import { InputGroupProps } from './input-group';
declare type InputControlPropsCleaned = Omit<InputControlProps, 'required' | 'value' | 'className' | 'elementRef' | 'id' | 'name' | 'type'>;
declare type InputGroupPropsCleaned = Omit<InputGroupProps, 'children'>;
declare type SupportedInputType = 'color' | 'date' | 'datetime' | 'datetime-local' | 'email' | 'hidden' | 'month' | 'number' | 'password' | 'range' | 'search' | 'tel' | 'text' | 'time' | 'url' | 'week';
declare const defaultProps: {
    blurCallback: (name: string, value: string) => void;
    blurDebounceInterval: number;
    changeDebounceInterval: number;
    className: string;
    elementRef: React.RefObject<HTMLInputElement>;
    keyDownCallback: (event: React.KeyboardEvent<HTMLInputElement>) => void;
    required: boolean;
    type: SupportedInputType;
    updateOnBlur: boolean;
    updateOnChange: boolean;
    value: string;
    changeCallback: (name: string, value: import("../types").ComponentValue) => void;
    elementWrapperClassName: import("classnames/types").ClassValue;
    errorMessages: React.ReactNode[];
    help: string;
    id: string;
    isPristine: boolean;
    label: React.ReactNode;
    labelClassName: import("classnames/types").ClassValue;
    layout: import("../types").LayoutType;
    onSetValue: (value: import("../types").ComponentValue) => void;
    rowClassName: import("classnames/types").ClassValue;
    showErrors: boolean;
};
declare type InputProps = InputControlPropsCleaned & InputGroupPropsCleaned & typeof componentDefaultProps & InputGroupProps & typeof defaultProps & {
    name: string;
};
interface State {
    currentValue: string;
    incomingPropValue: string;
    valueIsChanging: boolean;
}
declare class Input extends React.Component<InputProps, State> {
    static defaultProps: {
        blurCallback: (name: string, value: string) => void;
        blurDebounceInterval: number;
        changeDebounceInterval: number;
        className: string;
        elementRef: React.RefObject<HTMLInputElement>;
        keyDownCallback: (event: React.KeyboardEvent<HTMLInputElement>) => void;
        required: boolean;
        type: SupportedInputType;
        updateOnBlur: boolean;
        updateOnChange: boolean;
        value: string;
        changeCallback: (name: string, value: import("../types").ComponentValue) => void;
        elementWrapperClassName: import("classnames/types").ClassValue;
        errorMessages: React.ReactNode[];
        help: string;
        id: string;
        isPristine: boolean;
        label: React.ReactNode;
        labelClassName: import("classnames/types").ClassValue;
        layout: import("../types").LayoutType;
        onSetValue: (value: import("../types").ComponentValue) => void;
        rowClassName: import("classnames/types").ClassValue;
        showErrors: boolean;
    };
    changeDebounced: any;
    blurDebounced: any;
    constructor(props: any);
    setValue: (value: any) => void;
    static getDerivedStateFromProps(props: any, state: any): null | Partial<State>;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    handleBlur: (event: any) => void;
    handleChange: (event: any) => void;
    handleKeyDown: (event: React.KeyboardEvent<HTMLInputElement>) => void;
    render(): JSX.Element;
}
export default Input;
