import * as React from 'react';
import { CommonProps as ControlCommonProps } from './controls/common-prop-types';
declare type ControlCommonPropsCleaned = Omit<ControlCommonProps, 'id' | 'name'>;
interface Option {
    disabled?: boolean;
    label: React.ReactNode;
    value: string;
}
declare const defaultProps: {
    options: Option[];
    required: boolean;
    type: "stacked" | "inline";
    value: string;
    changeCallback: (name: string, value: import("../types").ComponentValue) => void;
    elementWrapperClassName: import("classnames/types").ClassValue;
    errorMessages: React.ReactNode[];
    help: string;
    id: string;
    isPristine: boolean;
    label: React.ReactNode;
    labelClassName: import("classnames/types").ClassValue;
    layout: import("../types").LayoutType;
    onSetValue: (value: import("../types").ComponentValue) => void;
    rowClassName: import("classnames/types").ClassValue;
    showErrors: boolean;
};
declare type RadioGroupProps = ControlCommonPropsCleaned & typeof defaultProps & {
    name: string;
};
declare class RadioGroup extends React.Component<RadioGroupProps, {}> {
    elements: {};
    static defaultProps: {
        options: Option[];
        required: boolean;
        type: "stacked" | "inline";
        value: string;
        changeCallback: (name: string, value: import("../types").ComponentValue) => void;
        elementWrapperClassName: import("classnames/types").ClassValue;
        errorMessages: React.ReactNode[];
        help: string;
        id: string;
        isPristine: boolean;
        label: React.ReactNode;
        labelClassName: import("classnames/types").ClassValue;
        layout: import("../types").LayoutType;
        onSetValue: (value: import("../types").ComponentValue) => void;
        rowClassName: import("classnames/types").ClassValue;
        showErrors: boolean;
    };
    constructor(props: any);
    private handleChange;
    private renderElement;
    render(): JSX.Element;
}
export default RadioGroup;
