var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import * as React from 'react';
import { componentDefaultProps } from './component-common';
import FormCheckGroup from './form-check-group';
var defaultProps = __assign(__assign({}, componentDefaultProps), { options: [], required: false, type: 'stacked', value: '' });
var RadioGroup = /** @class */ (function (_super) {
    __extends(RadioGroup, _super);
    function RadioGroup(props) {
        var _this = _super.call(this, props) || this;
        _this.elements = {};
        _this.handleChange = function (event) {
            var value = event.currentTarget.value;
            var _a = _this.props, onSetValue = _a.onSetValue, changeCallback = _a.changeCallback, name = _a.name;
            onSetValue(value);
            changeCallback(name, value);
        };
        _this.renderElement = function () {
            var _a = _this.props, disabled = _a.disabled, errorMessages = _a.errorMessages, id = _a.id, name = _a.name, options = _a.options, required = _a.required, showErrors = _a.showErrors, type = _a.type, value = _a.value;
            var markAsInvalid = showErrors && (errorMessages.length > 0 || required);
            var className = "custom-control custom-radio" + (type === 'inline' ? ' custom-control-inline' : '');
            var inputClassName = "custom-control-input" + (markAsInvalid ? ' is-invalid' : '');
            var controls = options.map(function (radio) {
                var checked = value === radio.value;
                var isDisabled = radio.disabled || disabled;
                var inputId = id + "--" + radio.value;
                var ref = React.createRef();
                _this.elements[radio.value] = ref;
                return (React.createElement("div", { className: className, key: radio.value },
                    React.createElement("input", { ref: ref, checked: checked, type: "radio", value: radio.value, onChange: _this.handleChange, disabled: isDisabled, className: inputClassName, name: name, id: inputId, required: required }),
                    React.createElement("label", { className: "custom-control-label", htmlFor: inputId }, radio.label)));
            });
            return controls;
        };
        return _this;
    }
    RadioGroup.prototype.render = function () {
        return (React.createElement(FormCheckGroup, __assign({}, this.props),
            React.createElement(React.Fragment, null, this.renderElement())));
    };
    RadioGroup.defaultProps = defaultProps;
    return RadioGroup;
}(React.Component));
export default RadioGroup;
//# sourceMappingURL=radio-group.js.map