import * as React from 'react';
import classNames from 'classnames/dedupe'; // eslint-disable-line import/default
import Label from './label';
var HorizontalElementWrapper = function (_a) {
    var children = _a.children, elementWrapperClassName = _a.elementWrapperClassName, renderLabel = _a.renderLabel;
    var wrapperClassNames = [];
    if (!renderLabel) {
        wrapperClassNames.push('offset-sm-3');
    }
    wrapperClassNames.push('col-sm-9');
    wrapperClassNames.push(elementWrapperClassName);
    return React.createElement("div", { className: classNames(wrapperClassNames) }, children);
};
var Row = function (_a) {
    var children = _a.children, _b = _a.elementWrapperClassName, elementWrapperClassName = _b === void 0 ? '' : _b, _c = _a.errorMessages, errorMessages = _c === void 0 ? [] : _c, _d = _a.fakeLabel, fakeLabel = _d === void 0 ? false : _d, _e = _a.htmlFor, htmlFor = _e === void 0 ? '' : _e, _f = _a.label, label = _f === void 0 ? null : _f, _g = _a.labelClassName, labelClassName = _g === void 0 ? '' : _g, _h = _a.layout, layout = _h === void 0 ? 'horizontal' : _h, _j = _a.required, required = _j === void 0 ? false : _j, _k = _a.rowClassName, rowClassName = _k === void 0 ? '' : _k, _l = _a.showErrors, showErrors = _l === void 0 ? false : _l;
    if (layout === 'elementOnly') {
        return React.createElement("span", null, children);
    }
    var rowClassNames = ['form-group'];
    if (showErrors && (errorMessages.length > 0 || required)) {
        rowClassNames.push('text-danger');
    }
    if (layout === 'horizontal') {
        rowClassNames.push('form-row');
    }
    rowClassNames.push(rowClassName);
    // We should render the label if there is label text defined, or if the
    // component is required (so a required symbol is displayed in the label tag)
    var renderLabel = label !== null || required;
    return (React.createElement("div", { className: classNames(rowClassNames) },
        renderLabel ? (React.createElement(Label, { fakeLabel: fakeLabel, htmlFor: htmlFor, label: label, labelClassName: labelClassName, layout: layout, required: required })) : null,
        layout === 'horizontal' ? (React.createElement(HorizontalElementWrapper, { elementWrapperClassName: elementWrapperClassName, renderLabel: renderLabel }, children)) : (children)));
};
export default Row;
//# sourceMappingURL=row.js.map