var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as React from 'react';
import debounce from '../debounce';
import { componentDefaultProps } from './component-common';
import ErrorMessages from './error-messages';
import Help from './help';
import Row from './row';
import TextareaControl from './controls/textarea';
var defaultProps = __assign(__assign({}, componentDefaultProps), { value: '', updateOnBlur: true, updateOnChange: true, blurDebounceInterval: 0, changeDebounceInterval: 500, cols: 0, rows: 3, 
    // eslint-disable-next-line @typescript-eslint/no-unused-vars, @typescript-eslint/no-empty-function
    blurCallback: function (name, value) { } });
var Textarea = /** @class */ (function (_super) {
    __extends(Textarea, _super);
    function Textarea(props) {
        var _this = _super.call(this, props) || this;
        _this.handleChange = function (event) {
            var _a = _this.props, updateOnChange = _a.updateOnChange, changeCallback = _a.changeCallback, name = _a.name;
            var value = event.currentTarget.value;
            _this.setState({ currentValue: value });
            if (updateOnChange) {
                _this.changeDebounced(value);
            }
            changeCallback(name, value);
        };
        _this.handleBlur = function (event) {
            var _a = _this.props, updateOnBlur = _a.updateOnBlur, blurCallback = _a.blurCallback, name = _a.name;
            var value = event.currentTarget.value;
            _this.setState({ currentValue: value });
            if (updateOnBlur) {
                _this.changeDebounced.cancel();
                _this.blurDebounced(value);
            }
            blurCallback(name, value);
        };
        var value = props.value, onSetValue = props.onSetValue, changeDebounceInterval = props.changeDebounceInterval, blurDebounceInterval = props.blurDebounceInterval;
        _this.state = {
            currentValue: value,
            incomingPropValue: value,
            valueIsChanging: false,
        };
        _this.changeDebounced = debounce(onSetValue, changeDebounceInterval);
        _this.blurDebounced = debounce(onSetValue, blurDebounceInterval);
        return _this;
    }
    Textarea.getDerivedStateFromProps = function (props, state) {
        var incomingPropValue = props.value;
        if (incomingPropValue !== state.incomingPropValue) {
            return {
                valueIsChanging: true,
                incomingPropValue: incomingPropValue,
            };
        }
        return null;
    };
    Textarea.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        var valueIsChanging = nextState.valueIsChanging, incomingPropValue = nextState.incomingPropValue;
        if (valueIsChanging === true) {
            this.setState({
                valueIsChanging: false,
                currentValue: incomingPropValue,
            });
            this.props.onSetValue(incomingPropValue);
            return false;
        }
        return true;
    };
    Textarea.prototype.render = function () {
        var inputProps = __rest(this.props, []);
        Object.keys(componentDefaultProps).forEach(function (key) {
            delete inputProps[key];
        });
        delete inputProps.blurDebounceInterval;
        delete inputProps.changeDebounceInterval;
        delete inputProps.updateOnBlur;
        delete inputProps.updateOnChange;
        delete inputProps.blurCallback;
        var currentValue = this.state.currentValue;
        var _a = this.props, className = _a.className, elementRef = _a.elementRef, errorMessages = _a.errorMessages, help = _a.help, id = _a.id, layout = _a.layout, name = _a.name, required = _a.required, showErrors = _a.showErrors;
        var markAsInvalid = showErrors && (errorMessages.length > 0 || required);
        var element = (React.createElement(TextareaControl, __assign({}, inputProps, { className: markAsInvalid ? "is-invalid " + className : className, id: id, value: currentValue, name: name, onChange: this.handleChange, onBlur: this.handleBlur, elementRef: elementRef })));
        if (layout === 'elementOnly') {
            return element;
        }
        return (React.createElement(Row, __assign({}, this.props, { htmlFor: id }),
            React.createElement(React.Fragment, null,
                element,
                help ? React.createElement(Help, { help: help }) : null,
                showErrors ? React.createElement(ErrorMessages, { messages: errorMessages }) : null)));
    };
    Textarea.defaultProps = defaultProps;
    return Textarea;
}(React.Component));
export default Textarea;
//# sourceMappingURL=textarea.js.map